PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Public Member Functions | List of all members
PSafeWork Class Referenceabstract

A PThreadPool work item template that uses PSafePtr to execute callback function. More...

`#include <threadpool.h>`

Inheritance diagram for PSafeWork:
[legend]
Collaboration diagram for PSafeWork:
[legend]

## Public Member Functions
| PSafeWork (PSafeObject *ptr)
virtual void | Work ()
virtual void | CallFunction (PSafeObject &obj)=0
Public Member Functions inherited from PSafePtrBase
virtual void | Assign (const PSafePtrBase &ptr)
virtual void | Assign (const PSafeCollection &safeCollection)
virtual void | Assign (PSafeObject *obj)
virtual void | Assign (PINDEX idx)
virtual Comparison | Compare (const PObject &obj) const
| Compare the pointers. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | SetNULL ()
| Set the pointer to NULL, unlocking/dereferencing existing pointer value. More...
bool | operator! () const
| Return true if pointer is NULL. More...
PSafeObject * | GetObject () const
| Return pointer to safe object. More...
template<class T >
T * | GetObjectAs () const
| Return pointer to safe object. More...
PSafetyMode | GetSafetyMode () const
| Get the locking mode used by this pointer. More...
virtual PBoolean | SetSafetyMode (PSafetyMode mode)
| Change the locking mode used by this pointer. More...
| ~PSafePtrBase ()
| Unlock and dereference the PSafeObject this is pointing to. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Additional Inherited Members
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...
Static Public Member Functions inherited from PObject
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
Protected Types inherited from PSafePtrBase
enum | EnterSafetyModeOption { WithReference, AlreadyReferenced }
enum | ExitSafetyModeOption { WithDereference, NoDereference }
Protected Member Functions inherited from PSafePtrBase
virtual void | Next ()
virtual void | Previous ()
virtual void | DeleteObject (PSafeObject *obj)
PBoolean | EnterSafetyMode (EnterSafetyModeOption ref)
void | ExitSafetyMode (ExitSafetyModeOption ref)
virtual void | LockPtr ()
virtual void | UnlockPtr ()
| PSafePtrBase (PSafeObject *obj=NULL, PSafetyMode mode=PSafeReference)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafeCollection &safeCollection, PSafetyMode mode, PINDEX idx)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafeCollection &safeCollection, PSafetyMode mode, PSafeObject *obj)
| Create a new pointer to a PSafeObject. More...
| PSafePtrBase (const PSafePtrBase &enumerator)
| Copy the pointer to the PSafeObject. More...
Protected Attributes inherited from PSafePtrBase
const PSafeCollection * | collection
PSafeObject * | currentObject
PSafetyMode | lockMode
Friends inherited from PObject

## Detailed Description

A PThreadPool work item template that uses PSafePtr to execute callback function.

## Constructor & Destructor Documentation

PSafeWork::PSafeWork | ( | PSafeObject * | ptr | ) |
| inline

## Member Function Documentation

virtual void PSafeWork::CallFunction | ( | PSafeObject & | obj | ) |
| pure virtual

Implemented in PSafeWorkArg3< PtrClass, Arg1Type, Arg2Type, Arg3Type, FuncRet >, PSafeWorkArg2< PtrClass, Arg1Type, Arg2Type, FuncRet >, PSafeWorkArg1< PtrClass, Arg1Type, FuncRet >, and PSafeWorkNoArg< PtrClass, FuncRet >.

Referenced by Work().

virtual void PSafeWork::Work | ( |  | ) |
| inline virtual

References CallFunction(), PSafePtrBase::GetObject(), and PTRACE_CONTEXT_ID_PUSH_THREAD.

The documentation for this class was generated from the following file:

- threadpool.h